notes/urls.py
from django.urls import path
from .views import add_note, index

urlpatterns = [
    path('', index, name='index'),
    path('add-note', add_note, name='add-note')
]

profile_page/urls.py
from django.conf import settings
from django.conf.urls.static import static
from django.urls import path
from .views import index, edit, get_profile, submit_profile


urlpatterns = [
    path('', index, name='index'),
    path('edit', edit, name='edit'),
    path('get-profile', get_profile, name='get-profile'),
    path('submit-profile', submit_profile, name ='submit-profile'),
] + static(settings.STATIC_URL, document_root=settings.STATIC_ROOT)

project/urls.py
from django.contrib import admin
from django.urls import include, path, re_path
from login_register.views import login as index
import tasks.urls as tasks
import profile_page.urls as profile
import weekly_schedule.urls as weekly_schedule
import personal_journal.urls as personal_journal
import pesanmotivasi.urls as pesan_motivasi
import notes.urls as notes
import login_register.urls as login_register
import authentication.urls as auth
from .router import router

urlpatterns = [
    path('admin/', admin.site.urls),
    path('notes/', include(notes)),
    path('tasks/',include(tasks)),
    path('profile/', include(profile)),
    path('weekly_schedule/', include(weekly_schedule)),
    path('account/', include(login_register)),
    path('personal_journal/', include(personal_journal)),
    path('motivasi/', include(pesan_motivasi)),
    path('auth/', include(auth)),
    path('api/',include(router.urls)),#khusus personal journal versi app
    re_path(r'^$', index, name='index'),
]

profile_page/models.py
from django.db import models
from django.contrib.auth.models import User
# from PIL import Image

class Profile(models.Model):
    user = models.OneToOneField(User, on_delete=models.CASCADE, null=True) # Delete profile when user is deleted
    name = models.CharField(max_length=100, blank=False)
    about = models.TextField(default="Hello!")
    image_name = models.CharField(max_length=20, default = 'default.jpg', blank=True)
    
    def save(self, *args, **kwargs):
        if self.pk is None:
            self.name = self.user.username
        super().save()

profile_page/forms.py
from django import forms
from .models import Profile

class ProfileEditForm(forms.ModelForm):
    class Meta:
        model = Profile
        fields = ['name', 'about', 'image_name']

profile_page/views.py
from django.http.response import JsonResponse
from django.shortcuts import render, redirect
from .models import Profile
from django.contrib.auth.models import User
from django.contrib.auth.decorators import login_required
from .forms import ProfileEditForm
from django.views.decorators.csrf import csrf_exempt
import json

@login_required(login_url='/admin/login/')
def index(request):
    profile = Profile.objects.filter(user=User.objects.get (username=request.user))
    response = {'profiles': profile}
    return render(request, 'profile_index.html', response)

@login_required(login_url='/admin/login/')
def edit(request):
    if request.method == 'POST':
        form = ProfileEditForm(request.POST, instance=request.user.profile) 
        if form.is_valid():
            print (form)
            form.save()
            return redirect('/profile')

    else:
        form = ProfileEditForm(instance=request.user.profile)

    context = {
        'form': form
    }

    return render(request, 'profile_edit.html', context)

@csrf_exempt
def get_profile(request):
    if request.method == 'GET':
        profile = Profile.objects.filter(user=User.objects.get (username=request.user))
        name = profile.values('name')[0]['name']
        about = profile.values('about')[0]['about']
        image_name = profile.values('image_name')[0]['image_name']
        data = {
            "name": name,
            "about": about,
            "imageUrl" : "http://notedote.herokuapp.com/static/img/" + image_name
        }
        return JsonResponse(data)

@csrf_exempt
def submit_profile(request):
    if request.method == 'POST':
        form = ProfileEditForm(request.POST, instance=request.user.profile)
        if form.is_valid():
            form.save()
            return JsonResponse({
                "status": True,
                "message": "Successfully submitted"
            }, status=200)
        else:
            return JsonResponse({
                "status": False,
                "message": "Failed to submit, name or about is invalid."
            }, status=401)
            

profile_page/templates/profile_edit.html
{% extends "base.html" %}
{% load static %}
{% block head %}
    <link rel="stylesheet" type="text/css" href= "{% static 'css/profilepage.css'%}">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0/css/bootstrap.min.css">
    <script>
        var closeModal = function(event) {
            document.getElementById('id01').style.display='none';
        };
        var openModal = function(event) {
            document.getElementById('id01').style.display='block';
        };
        var generateImg = function(event) {
            fetchJSONFile('/static/img-name.json', function(data){
                var file_names = data.files;
                file_names.forEach((file_name) => {
                    var img = document.createElement("img");
                    img.src = "/static/img/" + file_name;
                    img.className = 'modal-img';
                    img.width = '250';
                    img.height ='250';
                    img.onclick = function() { selectImage(file_name);closeModal();};
                    var wrap = document.createElement('div');
                    wrap.className = 'modal-container';
                    wrap.appendChild(img);
                    var src = document.getElementById("modal-content");
                    src.appendChild(wrap);
                });
            });
        }
        var selectImage = function(image_name) {
            var field = document.getElementById("id_image_name");
            field.value = image_name;
            var img = document.getElementById("profile-pic");
            img.src = "/static/img/" + image_name;
        }
        function fetchJSONFile(path, callback) {
            var httpRequest = new XMLHttpRequest();
            httpRequest.onreadystatechange = function() {
                if (httpRequest.readyState === 4) {
                    if (httpRequest.status === 200) {
                        var data = JSON.parse(httpRequest.responseText);
                        if (callback) callback(data);
                    }
                }
            };
            httpRequest.open('GET', path);
            httpRequest.send(); 
        }
    </script>
{% endblock head %}

{% block navbar %}
    <header>
            <div class="header-right">
                <a href="/profile"><b>Your Profile</b></a>
            </div>
    </header> 
{% endblock navbar %}

{% block content %}
    <div class="form-container">
        <form method="POST" enctype="multipart/form-data">
            {% csrf_token %}
            {{form.image_name.as_hidden}}
            <div class = "container" id = "image-box">
                <img id = "profile-pic" src="/static/img/{{form.image_name.value}}" class="rounded" wdith='250' height='250'>
                <button type="button" class="btn btn-secondary btn-sm" onclick='openModal()'>Change</button>
            </div>
            <div class="mb-3">
                <label for="id_name" class="form-label">Name</label>
                <input type="text" class="form-control" name="name" id="id_name"  maxlength="100" required="" value="{{ form.name.value }}">
            </div>
            <div class="mb-3">
                <label for="id_about" class="form-label">About</label>
                <textarea class="form-control" name="about" id="id_about" rows="9" required="" >{{form.about.value}}</textarea>
            </div>
            <button type="submit" class="btn btn-secondary">Submit</button>
        </form>
    </div>

    

    <div id="id01" class="modal" tabindex="-1" role="dialog" aria-labelledby="..." aria-hidden="true">
        <div class="modal-dialog modal-lg" role="document">
            <div class="modal-content">
                <div class="modal-body" id="modal-content">
                </div>
            <div class="modal-footer">
                <button type="button" class="btn btn-light" onclick='closeModal()'>Cancel</button>
            </div>
        </div>
    </div>

    <script> generateImg(); </script>
{% endblock content %}

profile_page/templates/profile_index.html
{% extends "base.html" %}
{% load static %}

{% block head %}
    <link rel="stylesheet" type="text/css" href= "{% static 'css/profilepage.css'%}">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0/css/bootstrap.min.css">
{% endblock head %}

{% block navbar %}
    <header>
            <div class="header-right">
                <a href="edit"><b>Edit Profile</b></a>
            </div>
    </header> 
{% endblock navbar %}



{% block content %}

    {% for profile in profiles %}

    <div class="profile-card">
        <div class="img-container">
            <img src="/static/img/{{profile.image_name}}" class = "profile-pic" id = "full-size">
        </div>
        <div class = "text-container">
            <h1 class = "name">{{ profile.name }}</h1>
            <p class="about-label">About</p>
            <div class="about-body">
                {{ profile.about }}
            </div>
        </div>
    </div>
    </div>
  {% endfor %}
{% endblock content %}